// elementx.js - White Label Ready

(function () {
    // ✅ CONFIGURAÇÃO CENTRAL - EDITÁVEL
    const whiteLabelConfig = {
        brandName: "ZapyHub",
        version: "3.8.0.9",

        logo: {
            old: "https://app.lotsofwms.in/assets/images/custom/SandroOliveira/SandroOliveira.png",
            new: "https://app.lotsofwms.in/assets/images/custom/SandroOliveira/SandroOliveira.png"
        },

        whatsapp: {
            oldNumber: "554198608485",
            newNumber: "557991313511"
        },

        customDomain: "zapyhub.com",

        links: {
            tutorials: "https://www.youtube.com/",
            requestFeature: "https://zapyhub.com/produto/botzo-crm-extensao-whatsapp/",
            privacyPolicy: "https://zapyhub.com/produto/botzo-crm-extensao-whatsapp/"
        },

        priceSymbolOld: "USD",
        priceSymbolNew: "R$",

        supportMessageEN: "Hello there! I am facing an issue with Extension. I need your assistance.",
        supportMessagePT: "Quero Saber Mais sobre o ZapyHub"
    };

    const brandFallback = "Botzo CRM";
    const version = whiteLabelConfig.version;

    const TRANSLATIONS = {
        "Botzo": brandFallback,
        "Botzo": brandFallback,
        "Extensão CRM": `${brandFallback} ${version}`,
        "Bem-vindo ao CRM": `Bem-vindo ao ${brandFallback} ${version}`,
        "Loading...": "Carregando...",
        "Monthly Plan": "Plano Mensal",
        "Yearly Plan": "Plano Anual",
        "WhatsApp CRM": brandFallback,
        "puppyCRM": brandFallback,
        "Premium 3 Days Trial": "- 3 Dias de Teste",
        "Message automation": "Automação de mensagens",
        "Unlimited messaging": "Mensagens ilimitadas",
        "Contact tagging and segmentation functionality": "Etiquetagem e segmentação de contatos",
        "Unlimited contact management": "Gerenciamento ilimitado de contatos",
        "Full conversation history": "Histórico completo de conversas",
        "Detailed reports and analysis": "Relatórios e análises detalhados",
        "Advanced integration with WhatsApp": "Integração avançada com WhatsApp",
        "Priority support via email and live chat": "Suporte prioritário por e-mail e chat ao vivo",
        "All features of the free plan": "Todos os recursos do plano gratuito",
        "R$ Get offer": "R$ Obter Oferta",
        "Get offer": "Obter Oferta",
        "Obtén oferta": "Obter Oferta",
        "buy": "COMPRAR",
        "USD": whiteLabelConfig.priceSymbolNew,
        "License Details": "Detalhes da Licença",
        "Here you will find detailed information about your license and options to uninstall it if necessary.": "Aqui você encontrará informações detalhadas sobre sua licença e opções para desinstalá-la, se necessário.",
        "User:": "Usuário:",
        "Phone:": "Telefone:",
        "License:": "Licença:",
        "Plan:": "Plano:",
        "Next Payment:": "Próximo Pagamento:",
        "Uninstall License": "Desinstalar Licença",
        "Close": "Fechar",
        "You must have Valid & Active License Key": "Você precisa de uma Chave de Licença Válida e Ativa",
        "Enter your license key & click on Activate to Activate your License Key.": "Insira sua chave de licença e clique em Ativar para ativar sua chave de licença.",
        "Activate Now": "Ativar Agora",
        "You must enter a key": "Você deve inserir uma chave",
        "Please enter your license key in the field below to activate advanced features.": "Insira sua chave de licença no campo abaixo para ativar recursos avançados.",
        "undefined": "indefinido",
        "Sort": "Organizar",
        "Validate": "VALIDAR",
        "Done": "Concluído",
        "To Do": "A Fazer",
        "Processing": "Processando",
        "Cancel": "Cancelar",
        "OK": "OK",
        "Column": "Coluna",
        "Digite o Nome da Coluna:": "Digite o Nome da Coluna:",
        "Adicionar": "Adicionar",
        "Excluir": "Excluir",
        "Inbox": "Caixa de Entrada",
        "Perto": "Fechar",
        "Cancelararararar": "Cancelar",
        "Cancelararar": "Cancelar",
        "Cancelarararar": "Cancelar",
        "Cancelarar": "Cancelar",
        "Recent 50 Chats": "50 Chats Recentes",

        // Nova tradução com <br> para exibição correta
        "Automação de mensagensMensagens ilimitadasEtiquetagem e segmentação de contatosGerenciamento ilimitado de contatosHistórico completo de conversasRelatórios e análises detalhadosIntegração avançada com WhatsAppSuporte prioritário por e-mail e chat ao vivoTodos os recursos do plano gratuito": "Recursos incluídos:<br>✅ Mensagens ilimitadas<br>✅ Automação de mensagens<br>✅ Etiquetagem e segmentação de contatos<br>✅ Gerenciamento ilimitado de contatos<br>✅ Histórico completo de conversas<br>✅ Relatórios e análises detalhados<br>✅ Integração avançada com o WhatsApp<br>✅ Suporte prioritário por e-mail e chat ao vivo<br>✅ Todos os recursos do plano gratuito incluídos",
        "Your private user panel": "Seu painel de usuário privado",
        "Tools": "Ferramentas",
        "Sets of free functions": "Conjuntos de funções gratuitas",
        "Functions": "Funções",
        "Import and export contacts, personalized links, and much more...": "Importe e exporte contatos, links personalizados e muito mais...",
        "Kanban Board": "Quadro Kanban",
        "Organize all your clients with this powerful tool": "Organize todos os seus clientes com esta ferramenta poderosa",
        "Quick Reply": "Resposta Rápida",
        "Reply quickly": "Responda rapidamente",
        "Scheduled Notifications": "Notificações Agendadas",
        "Notify a customer in the future": "Notifique um cliente no futuro",
        "Outgoing Webhooks": "Webhooks de Saída",
        "Connect with Outer World": "Conecte-se com o Mundo Exterior",
        "Chatbots": "Chatbots",
        "Create and customize your autoresponder chatbot": "Crie e personalize seu chatbot de resposta automática",
        "Scheduled Broadcasts": "Transmissões Agendadas",
        "Schedule all your messages": "Agende todas as suas mensagens",
        "Templates": "Modelos",
        "Create and organize your templates": "Crie e organize seus modelos",
        "Flash Broadcasts": "Transmissões Rápidas",
        "Quick and emergency broadcasts": "Transmissões rápidas e de emergência",
        "Custom Tabs": "Abas Personalizadas",
        "Loading libraries…": "Carregando",
		"Choose Your Plan": "Escolha Seu Plano",
		"If you already have a license, click here to access:": "Se você já possui uma licença, clique aqui para acessar:",
		"Enter key": "Inserir chave",
		"Month": "Mensal",
		"Year": "Anual",
		"Buy": "Comprar",
        "Just a moment, we’ll be done shortly": "Aguarde um momento",
		"Is your license expired? Don't worry, renew easily and go back to enjoying all the benefits. Keep your access active and avoid interruptions in your service. Click now to renew and continue without problems!": "Sua licença expirou? Não se preocupe, renove facilmente e volte a aproveitar todos os benefícios. Mantenha seu acesso ativo e evite interrupções no serviço. Clique agora para renovar e continuar sem problemas!",
		"Renew License": "Renovar Licença",
        "Pair your labels and organize like a pro": "Emparelhe suas etiquetas e organize como um profissional"
    };

    function replaceTexts() {
        document.querySelectorAll("*:not(script):not(style)").forEach((element) => {
            element.childNodes.forEach((node) => {
                if (node.nodeType === Node.TEXT_NODE) {
                    Object.entries(TRANSLATIONS).forEach(([key, value]) => {
                        if (node.nodeValue.includes(key) && !node.nodeValue.includes(value)) {
                            // Substituição especial com HTML
                            if (value.includes("<br>")) {
                                const span = document.createElement("span");
                                span.innerHTML = node.nodeValue.replace(new RegExp(key, "g"), value);
                                node.replaceWith(span);
                            } else {
                                node.nodeValue = node.nodeValue.replace(new RegExp(key, "g"), value);
                            }
                        }
                    });
                }
            });
        });
    }

    function replaceLogo() {
        document.querySelectorAll(`img[src="${whiteLabelConfig.logo.old}"]`).forEach((img) => {
            img.src = whiteLabelConfig.logo.new;
        });
    }

    function replaceLinks() {
        const TARGET_LINKS = [
            "https://web.whatsapp.com/[object%20Object]",
            "https://wa.me/#?text=WA%20CRM%201%20Days%20Trail",
            "https://web.whatsapp.com/#",
			"https://https//zapyhub.com/buy/precios",
			"https://https//inftag.com/buyninjaflow/precios",
			"https://web.whatsapp.com/undefined",
            "https://zapyhub.com/feedback" // ✅ Adicionado aqui
        ];

        document.querySelectorAll("a").forEach((link) => {
            TARGET_LINKS.forEach((target) => {
                if (link.href.includes(target)) {
                    link.href = whiteLabelConfig.customDomain;
                }
            });

            if (link.href.includes("zapyhub.com")) {
            link.href = link.href.replace(/plwdesign\.online/g, whiteLabelConfig.customDomain);
        }

       if (link.href.includes("web.whatsapp.com")) {
    link.href = whiteLabelConfig.customDomain.startsWith("http")
        ? whiteLabelConfig.customDomain
        : "https://" + whiteLabelConfig.customDomain;
}

if (link.href.includes("lotsofcode.in/precios")) {
    link.href = whiteLabelConfig.customDomain.startsWith("http")
        ? whiteLabelConfig.customDomain
        : "https://" + whiteLabelConfig.customDomain;
}


    });
}

    function replaceSpecialLinks() {
        const { tutorials, requestFeature, privacyPolicy } = whiteLabelConfig.links;

        document.querySelectorAll("a").forEach((link) => {
            if (link.href.includes("/tutorials")) link.href = tutorials;
            if (link.href.includes("/request-feature")) link.href = requestFeature;
            if (link.href.includes("/privacy-policy")) link.href = privacyPolicy;
        });
    }

    function replacePrices() {
        document.querySelectorAll("div, span, p").forEach((el) => {
            if (el.innerText.includes(whiteLabelConfig.priceSymbolOld)) {
                el.innerText = el.innerText.replace(whiteLabelConfig.priceSymbolOld, whiteLabelConfig.priceSymbolNew);
            }
        });
    }

    function ensureWhatsAppLinkAlwaysUpdated() {
        const { oldNumber, newNumber } = whiteLabelConfig.whatsapp;

        document.querySelectorAll("a[href*='wa.me']").forEach((link) => {
            if (link.href.includes(oldNumber)) {
                link.href = link.href.replace(oldNumber, newNumber);
            }

            link.addEventListener("click", () => {
                if (link.href.includes(oldNumber)) {
                    link.href = link.href.replace(oldNumber, newNumber);
                }
            });
        });
    }

    function forceWhatsAppReplacementRepeatedly() {
        let attempts = 0;
        const interval = setInterval(() => {
            ensureWhatsAppLinkAlwaysUpdated();
            if (++attempts >= 10) clearInterval(interval);
        }, 1000);
    }

    function replaceMessages() {
        const { supportMessageEN, supportMessagePT } = whiteLabelConfig;

        document.querySelectorAll("*:not(script):not(style)").forEach((el) => {
            el.childNodes.forEach((node) => {
                if (node.nodeType === Node.TEXT_NODE && node.nodeValue.includes(supportMessageEN)) {
                    node.nodeValue = node.nodeValue.replace(new RegExp(supportMessageEN, "g"), supportMessagePT);
                }
            });
        });
    }
	
	function forceTextColorForSpecificTexts() {
    const exactMatches = {
        "Aguarde um momento": true,
        "Carregando": true,
        "Carregando bibliotecas…": true,
        "Aguarde um momento, logo estaremos prontos": true
    };

    document.querySelectorAll("*:not(script):not(style)").forEach((el) => {
        const text = el.textContent.trim();
        if (exactMatches[text]) {
            el.style.color = "black";
        }
    });
}

    function fixGroupMessageSending() {
        const originalSendTextMsgToChat = window.Store?.SendTextMsgToChat;

        if (originalSendTextMsgToChat) {
            window.Store.SendTextMsgToChat = async function (chat, ...args) {
                try {
                    if (chat.isGroup && !chat.id.server.includes("g.us")) {
                        chat.id.server = "g.us";
                    }
                    return originalSendTextMsgToChat.apply(this, [chat, ...args]);
                } catch (error) {
                    console.error("Erro ao corrigir envio para grupos:", error);
                }
            };
        }
    }

    function monitorDOMChanges() {
        const observer = new MutationObserver(() => {
            replaceTexts();
            replaceLogo();
            replaceLinks();
            replaceSpecialLinks();
            replacePrices();
            ensureWhatsAppLinkAlwaysUpdated();
            replaceMessages();
			forceTextColorForSpecificTexts(); // ✅ aqui também
            interceptUninstallFeedbackLink(); // ✅ aqui também
        });

        observer.observe(document.body, { childList: true, subtree: true });
    }

    function initialize() {
        const main = () => {
            replaceTexts();
            replaceLogo();
            replaceLinks();
            replaceSpecialLinks();
            replacePrices();
            ensureWhatsAppLinkAlwaysUpdated();
            forceWhatsAppReplacementRepeatedly();
            replaceMessages();
            fixGroupMessageSending();
			forceTextColorForSpecificTexts(); // ✅ aqui
            interceptUninstallFeedbackLink(); // ✅ aqui também
            monitorDOMChanges();
        };

        if (document.readyState === "loading") {
            document.addEventListener("DOMContentLoaded", main);
        } else {
            main();
        }
    }


    function interceptUninstallFeedbackLink() {
    document.querySelectorAll("a[href*='zapyhub.com/feedback']").forEach((link) => {
        link.addEventListener("click", (e) => {
            e.preventDefault();
            window.open(whiteLabelConfig.customDomain, "_blank");
        });
        // reforça o fallback (ex: botão de contexto do Chrome)
        link.href = whiteLabelConfig.customDomain;
    });
}



    initialize();
})();
